!--------1---------2---------3---------4---------5---------6---------7---------8
! 
!> Program  cg_main
!! @brief   convert charmm psf file to go parameter file
!! @authors Takaharu Mori (TM)
!
!  (c) Copyright 2014 RIKEN. All rights reserved.
!
!--------1---------2---------3---------4---------5---------6---------7---------8

#ifdef HAVE_CONFIG_H
#include "../../../config.h"
#endif

program cg_main

  use cg_convert_mod
  use cg_setup_mod
  use cg_control_mod
  use cg_option_str_mod
  use output_str_mod
  use input_str_mod
  use string_mod
  use messages_mod
  use timers_mod
  use mpi_parallel_mod

  implicit none

  ! local variables
  character(MaxFilename) :: ctrl_filename
  type(s_ctrl_data)      :: ctrl_data
  type(s_input)          :: input
  type(s_option)         :: option
  type(s_output)         :: output


  my_city_rank = 0
  nproc_city   = 1
  main_rank    = .true.

  ! show usage
  !
  call usage(ctrl_filename)

  ! [Step1] Read control file
  !
  write(MsgOut,'(A)') '[STEP1] Read Control Parameters'
  write(MsgOut,'(A)') ' '

  call control(ctrl_filename, ctrl_data)


  ! [Step2] Set relevant variables and structures 
  !
  write(MsgOut,'(A)') '[STEP2] Set Relevant Variables and Structures'
  write(MsgOut,'(A)') ' '

  call setup(ctrl_data, input, option, output)


  ! [Step3] Convert charmm psffile to gprfile
  !
  write(MsgOut,'(A)') '[STEP3] Convert charmm psffile to gprfile'
  write(MsgOut,'(A)') ' '

  call convert(input, output, option)


  stop

end program cg_main
