!--------1---------2---------3---------4---------5---------6---------7---------8
!
!  Module   cg_option_str_mod
!> @brief   structure of option information
!! @authors Takaharu Mori (TM)
! 
!  (c) Copyright 2014 RIKEN. All rights reserved.
!
!--------1---------2---------3---------4---------5---------6---------7---------8

#ifdef HAVE_CONFIG_H
#include "../../../config.h"
#endif

module cg_option_str_mod

  use constants_mod

  implicit none
  private

  ! structures
  type, public :: s_option
    logical    :: check_only
    integer    :: forcefield
    real(wp)   :: k_bond 
    real(wp)   :: k_angle 
    real(wp)   :: k_improper 
    real(wp)   :: e_dihedral
    real(wp)   :: e_c
    real(wp)   :: e_nc 
    real(wp)   :: s_nc 
    real(wp)   :: r_cd 
    real(wp)   :: r_bbsc 
    real(wp)   :: cutoff 
    integer    :: min_dist 
    real(wp)   :: r_scale 
  end type s_option

  ! parameters
  integer,      public, parameter :: ForceFieldAAGO = 1
  
  character(*), public, parameter :: ForceFieldTypes(1) = (/'AAGO'/)

end module cg_option_str_mod
